VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Palindromic Dates"
   ClientHeight    =   3135
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2745
   LinkTopic       =   "Form1"
   ScaleHeight     =   3135
   ScaleWidth      =   2745
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSearch2 
      Caption         =   "Search 2"
      Height          =   375
      Left            =   1200
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
   Begin VB.TextBox txtResults 
      Height          =   2535
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   600
      Width           =   2655
   End
   Begin VB.CommandButton cmdSearch1 
      Caption         =   "Search 1"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdSearch1_Click()
Dim d As Integer
Dim m As Integer
Dim d_str As String
Dim m_str As String
Dim y_str As String
Dim date_str As String
Dim test_date As Date
Dim txt As String
Dim num_dates As Integer

    For m = 1 To 12
        m_str = Format$(m, "00")
        For d = 1 To 31
            d_str = Format$(d, "00")
            y_str = Mid$(d_str, 2, 1) & _
                    Mid$(d_str, 1, 1) & _
                    Mid$(m_str, 2, 1) & _
                    Mid$(m_str, 1, 1)
            date_str = m_str & "/" & d_str & "/" & y_str

            ' See if this is a valid date.
            ' Eg. eliminate 2/31/3000.
            On Error Resume Next
            test_date = CDate(date_str)
            If Err.Number <> 0 Then
                Err.Clear
            Else
                txt = txt & date_str & vbCrLf
                num_dates = num_dates + 1
            End If
            On Error GoTo 0
        Next d
    Next m

    txtResults.Text = txt
    MsgBox "Found " & Format$(num_dates) & " palindromic dates"
End Sub
Private Sub cmdSearch2_Click()
Dim d_list As Variant
Dim m_list As Variant
Dim d_num As Integer
Dim m_num As Integer
Dim d_str As String
Dim m_str As String
Dim y_str As String
Dim date_str As String
Dim test_date As Date
Dim txt As String
Dim num_dates As Integer
Dim palindromic_dates As Collection

    ' Initialize the lists of day and month numbers.
    d_list = Array( _
        10, 20, 30, _
        1, 11, 21, 31, _
        2, 12, 22, _
        3, 13, 23, _
        4, 14, 24, _
        5, 15, 25, _
        6, 16, 26, _
        7, 17, 27, _
        8, 18, 28, _
        9, 19, 29)
    m_list = Array(10, 1, 11, 2, 12, 3, 4, 5, 6, 7, 8, 9)

    Set palindromic_dates = New Collection

    For d_num = LBound(d_list) To UBound(d_list)
        d_str = Format$(d_list(d_num), "00")
        For m_num = LBound(m_list) To UBound(m_list)
            m_str = Format$(m_list(m_num), "00")
            y_str = Mid$(d_str, 2, 1) & _
                    Mid$(d_str, 1, 1) & _
                    Mid$(m_str, 2, 1) & _
                    Mid$(m_str, 1, 1)
            date_str = m_str & "/" & d_str & "/" & y_str

            ' See if this is a valid date.
            ' Eg. eliminate 2/31/3000.
            On Error Resume Next
            test_date = CDate(date_str)
            If Err.Number <> 0 Then
                Err.Clear
            Else
                txt = txt & date_str & vbCrLf
                num_dates = num_dates + 1
                palindromic_dates.Add date_str
            End If
            On Error GoTo 0
        Next m_num
    Next d_num

    ' Verify the results.
    For d_num = 2 To palindromic_dates.Count
        If CDate(palindromic_dates(d_num - 1)) >= CDate(palindromic_dates(d_num)) Then
            MsgBox "Error: " & _
                palindromic_dates(d_num - 1) & " >= " & _
                palindromic_dates(d_num)
        End If
    Next d_num
    
    txtResults.Text = txt
    MsgBox "Found " & Format$(num_dates) & " palindromic dates"
End Sub
Private Sub Form_Resize()
Dim hgt As Single

    cmdSearch1.Left = ScaleWidth / 2 - cmdSearch1.Width - 120
    cmdSearch2.Left = ScaleWidth / 2 + 120

    hgt = ScaleHeight - (cmdSearch1.Top + cmdSearch1.Height) - 30
    If hgt < 120 Then hgt = 120
    txtResults.Move 0, cmdSearch1.Top + cmdSearch1.Height + 30, ScaleWidth, hgt
End Sub


